<?php
/**
 * Diafan.CMS
 *
 * @author     Denis (aka Racoon) Bazhenov
 * @version    5.0
 * @copyright  Copyright (c) 2012 OOO "Онлайн Мастер". (http://onmaster.ru)
 */

if (! defined('DIAFAN')) include dirname(dirname(dirname(__FILE__))).'/includes/404.php'; 

/**
 * Auto_ajax
 *
 * Обработка запроса при выборе родительского поля
 */
class Auto_ajax extends Ajax {
    /**
     * Обрабатывает полученные данные из формы
     * 
     * @return boolean
     */
    public function ajax_request(){
        if (empty($_POST['module']) || $_POST['module'] != 'auto' || empty($_POST['action'])) {
            return false;
        }
        
        switch($_POST['action']) {
            case 'get_model':
                return $this->get_model();
            case 'get_year':
                return $this->get_year();
            case 'get_bodyengin':
                return $this->get_bodyengin();
            case 'get_disksize':
                return $this->get_disksize();
        }
        
        // а вот если запрос не подходит под выше перечисленные
        return false;
    }

    /**
     * Выбираем модели согласно производителю
     * 
     * @return boolean
     */
    private function get_model() {
        if (!empty($_POST['module']) && $_POST['module'] === "auto"){
            // выбраем все модельки и формировуем кишки для селекта моделей
            $data = "";
            $result = DB::query("SELECT `model` FROM {auto} WHERE `manufacturer`='%s' GROUP BY `model` ASC",$_POST['manufacturer']);
            while ($row = DB::fetch_array($result)) {
                $data .= '<option value="'. $row["model"] .'">'. $row["model"] .'</option>';
            } 
            $this->result["target"] = "select[name='model']"; // выбираем селектор но его лучше определить в JS при выборе
            $this->result["data"] = (isset($data)&&!empty($data)) ? $data : "";
            return $this->send_errors(); // отправляем ответ на сервак странное название метода
        }
        return false;
    }

    /**
     * Формируем диапазон лет согласно летописи конкретной модели
     * 
     * @return boolean
     */
    private function get_year() {
        if (!empty($_POST['module']) && $_POST['module'] === "auto"){
            // выбраем все модельки и формировуем кишки для селекта годов выпуска
            $max_time = "0000-00-00";
            $now_time = $min_time = date('Y-m-d');
            $result = DB::query("SELECT `startprod`, `endprod` FROM {auto} WHERE `manufacturer`='%s' AND `model`='%s'", $_POST['manufacturer'], $_POST['model']);
            while ($row = DB::fetch_array($result)) {
                if ($row["endprod"] === "0000-00-00") $row["endprod"] = $now_time;
                if ($min_time > $row["startprod"]) $min_time = $row["startprod"];
                if ($max_time < $row["endprod"]) $max_time = $row["endprod"];
            } 
            $max_time = substr ($max_time, 0, 4);
            $min_time = substr ($min_time, 0, 4);
            $data = "";
            for ($i=$max_time; $i>=$min_time; $i--) {
                $data .= '<option value="'. $i .'">'. $i .'</option>';            
            }
            $this->result["target"] = "select[name='production']"; // выбираем селектор но его лучше определить в JS при выборе
            $this->result["data"] = (isset($data)&&!empty($data)) ? $data : "";
            return $this->send_errors(); // отправляем ответ на сервак странное название метода
        }
        return false;
    }
    
    /**
     * Выбираем модификацию кузова и двигателя согласно году выпуска
     * 
     * @return boolean
     */
    private function get_bodyengin() {
        if (!empty($_POST['module']) && $_POST['module'] === "auto"){
            // выбраем все модельки и формировуем кишки для селекта кузовов и движков
            $data = "";
            $result = DB::query("SELECT `carbody_engine`, `startprod`, `endprod` FROM {auto} WHERE `manufacturer`='%s' AND `model`='%s' GROUP BY `carbody_engine` ASC", $_POST['manufacturer'], $_POST['model']);
            while ($row = DB::fetch_array($result)) {
                if ($row["endprod"]==="0000-00-00") $row["endprod"]= date('Y-m-d');
                $_POST['production'] = htmlspecialchars(trim($_POST['production']));
                if (strlen($_POST['production']) === 4) {
                    //$row['startprod'] = strtotime($row[`startprod`]);
                    //$row['endprod'] = strtotime($row[`endprod`]);
                    //$s_P = strtotime($_POST['production'].'-12-31');
                    //$e_P = strtotime($_POST['production'].'-01-01');
                    //if ($row['startprod'] <= $s_P && $row['endprod'] >= $e_P) {
                    if ($row['startprod'] <= $_POST['production'].'-12-31' && $row['endprod'] >= $_POST['production'].'-01-01') {
                        $data .= '<option value="'. $row["carbody_engine"] .'">'. $row["carbody_engine"] .'</option>';
                    }
                }
            } 
            $this->result["target"] = "select[name='bodyengine']"; // выбираем селектор но его лучше определить в JS при выборе проблемка данное поле не пробрасывается
            $this->result["data"] = (isset($data)&&!empty($data)) ? $data : "";
            return $this->send_errors(); // отправляем ответ на сервак странное название метода
        }       
        return false;
    }
    
    /**
     * Выбираем размер диска согласно выше выбраным параметрам
     * 
     * @return boolean
     */
    private function get_disksize() {
        if (!empty($_POST['module']) && $_POST['module'] === "auto"){
            // выбраем все модельки и формировуем кишки для селекта размер дисков
            $data = "";
            $result = DB::query("SELECT `disksize` FROM {auto} WHERE `manufacturer`='%s' AND `model`='%s' AND `carbody_engine`='%s'", $_POST['manufacturer'], $_POST['model'], $_POST['bodyengine']);
            while ($row = DB::fetch_array($result)) {
                $data .= '<option value="'. $row["disksize"] .'">'. $row["disksize"] .'</option>';
            } 
            $this->result["target"] = "select[name='disksize']"; // выбираем селектор но его лучше определить в JS при выборе
            $this->result["data"] = (isset($data)&&!empty($data)) ? $data : "";
            return $this->send_errors(); // отправляем ответ на сервак странное название метода
        }
        return false;
    }
}
?>
