<?php
/**
 * Diafan.CMS
 *
 * @author     Denis (aka Racoon) Bazhenov
 * @version    5.0
 * @copyright  Copyright (c) 2012 OOO "Онлайн Мастер". (http://onmaster.ru)
 */

if (!defined('DIAFAN')) {
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Auto_model
 *
 * Модель модуля "Список автомобилей"
 */
class Auto_model extends Model {
    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct(&$diafan) {
        $this->diafan = &$diafan;
    }
    
    /**
     * Генерирует данные для списка товаров, найденных при помощи поиска
     * 
     * @return boolean
     */
    public function list_search() {
        $this->result["path"] = $this->get_path('auto');
        $this->result["titlemodule"] = _LANG_SEARCH_BY_AUTO;
        if (!empty($_GET["manufacturer"])) {
            // Заготавливаем списки значений параметров являющиеся селектами чекбоксами радиобатонами и прочими мультипульти
            $list_param = DB::query("SELECT `id`, `param_id`, `name` FROM {shop_param_select} WHERE `trash` = '0'");
            while ($row = DB::fetch_array($list_param)) {
                $param[$row['param_id']][$row['name']] = $row['id'];
            }
            unset($list_param);
            
            // параметры для поиска шин
            $request = "SELECT pr.`parent`, pr.`width`, pr.`profile`, pr.`disksize` FROM {auto} AS s ".
                       "INNER JOIN {auto_tire} AS pr ON pr.auto_id=s.id ".
                       "WHERE s.manufacturer = '%s' ".
                       (!empty($_GET["model"]) ? "AND s.model = '%s' " : "").
                       (!empty($_GET["production"]) ? "AND s.startprod <= '%s' AND (s.endprod >= '%s' OR s.endprod = '0000-00-00') " : "").
                       (!empty($_GET["bodyengine"]) ? "AND s.carbody_engine = '%s' " : "").
                       (!empty($_GET["disksize"]) ? "AND s.disksize = '%s'" : "");

            if (!empty($_GET["disksize"])&&!empty($_GET["bodyengine"])&&!empty($_GET["production"])&&!empty($_GET["model"])&&!isset($tires_par)) {
                $tires_par = DB::query($request, $_GET["manufacturer"], $_GET["model"], $_GET["production"].'-12-31',$_GET["production"].'-01-01', $_GET["bodyengine"], $_GET["disksize"]);
            } elseif (!empty($_GET["bodyengine"])&&!empty($_GET["production"])&&!empty($_GET["model"])&&!isset($tires_par)) {
                $tires_par = DB::query($request, $_GET["manufacturer"], $_GET["model"], $_GET["production"].'-12-31',$_GET["production"].'-01-01', $_GET["bodyengine"]);
            } elseif (!empty($_GET["production"])&&!empty($_GET["model"])&&!isset($tires_par)) {
                $tires_par = DB::query($request, $_GET["manufacturer"], $_GET["model"], $_GET["production"].'-12-31',$_GET["production"].'-01-01');
            } elseif (!empty($_GET["model"])&&!isset($tires_par)) {
                $tires_par = DB::query($request, $_GET["manufacturer"], $_GET["model"]);
            } else {
                $tires_par = DB::query($request, $_GET["manufacturer"]);
            }
            
            while ($row = DB::fetch_array($tires_par)) {
                // подготовить $row["width"] $row["profile"] $row["disksize"] согласно данным в таблице
                // $row["width"] если после точки нуль надо отсеч
                $iga = preg_split("[\.]", $row["width"]);
                if (isset($iga[1]) && $iga[1] == '0') $row["width"] = (int)$row["width"];
                // $row["profile"] если после точки нуль надо отсеч
                $iga = preg_split("[\.]", $row["profile"]);
                if (isset($iga[1]) && $iga[1] == '0') $row["profile"] = (int)$row["profile"];
                // $row["disksize"] надо отсеч первый знак
                $iga = preg_split('[R]', $row["disksize"]);
                $row["disksize"] = $iga[1];
                
                    // Делаем выборки по параметрам полученным на основании марки авто
                    $where =
                        "INNER JOIN {shop_param_element} AS pe1 ON pe1.`element_id` = s.`id` AND pe1.`trash` = '0' AND pe1.`param_id` = 1 AND pe1.`value` = '".(isset($param[1][$row["width"]]) ? $param[1][$row["width"]] : '')."' ".
                        "INNER JOIN {shop_param_element} AS pe2 ON pe2.`element_id` = s.`id` AND pe2.`trash` = '0' AND pe2.`param_id` = 2 AND pe2.`value` = '".(isset($param[2][$row["profile"]]) ? $param[2][$row["profile"]] : '')."' ".
                        "INNER JOIN {shop_param_element} AS pe3 ON pe3.`element_id` = s.`id` AND pe3.`trash` = '0'  AND pe3.`param_id` = 3 AND pe3.`value` = '".(isset($param[3][$row["disksize"]]) ? $param[3][$row["disksize"]] : '')."' ";

                    $result = DB::query("SELECT s.`id`, s.`cat_id`, s.`site_id`, s.`name`, s.`hit`, s.`new`, s.`action`, pr.`price` ".
                                "FROM {shop} AS s ".
                                "INNER JOIN {shop_price} AS pr ON pr.good_id = s.id AND pr.trash = '0' ".
                                $where.
                                "WHERE s.[act] = '1' AND s.trash = '0' ".
                                "GROUP BY s.id"
                                );
                 if ($row["parent"] == 1) {
                    while ($row = DB::fetch_array($result)) {
                        $this->result["parent_tyres"][] = array('name'=>$row["name"], 'link' => $this->diafan->_route->link($row["site_id"], "shop", $row["cat_id"], $row["id"]), 'hit'=>$row["hit"], 'new'=>$row["new"], 'action'=>$row["action"], 'price'=>$this->diafan->format_price($row["price"]), 'show_rating' => $this->diafan->_rating->get($row["id"]));
                    }
                } elseif ($row["parent"] == 0) {
                    while ($row = DB::fetch_array($result)) {
                        $this->result["variant_tyres"][] = array('name'=>$row["name"], 'link' => $this->diafan->_route->link($row["site_id"], "shop", $row["cat_id"], $row["id"]), 'hit'=>$row["hit"], 'new'=>$row["new"], 'action'=>$row["action"], 'price'=>$this->diafan->format_price($row["price"]), 'show_rating' => $this->diafan->_rating->get($row["id"]));
                    }                    
                }
                    
            }
            
            // параметры для поиска дисков
            $request = "SELECT pr.`parent`, pr.`width_min`, pr.`width_max`, pr.`diametr`, pr.`pcd`, pr.`dia_min`, pr.`dia_max`, pr.`et_min`, pr.`et_max` FROM {auto} AS s ".
                       "INNER JOIN {auto_disk} AS pr ON pr.auto_id=s.id ".
                       "WHERE s.manufacturer = '%s' ".
                       (!empty($_GET["model"]) ? "AND s.model = '%s' " : "").
                       (!empty($_GET["production"]) ? "AND s.startprod <= '%s' AND (s.endprod >= '%s' OR s.endprod = '0000-00-00') " : "").
                       (!empty($_GET["bodyengine"]) ? "AND s.carbody_engine = '%s' " : "").
                       (!empty($_GET["disksize"]) ? "AND s.disksize = '%s'" : "");
            
            if (!empty($_GET["disksize"])&&!empty($_GET["bodyengine"])&&!empty($_GET["production"])&&!empty($_GET["model"])&&!isset($disk_par)) {
                $disk_par = DB::query($request, $_GET["manufacturer"], $_GET["model"],$_GET["production"].'-12-31', $_GET["production"].'-01-01', $_GET["bodyengine"], $_GET["disksize"] );
            } elseif (!empty($_GET["bodyengine"])&&!empty($_GET["production"])&&!empty($_GET["model"])&&!isset($disk_par)) {
                $disk_par = DB::query($request, $_GET["manufacturer"], $_GET["model"],$_GET["production"].'-12-31', $_GET["production"].'-01-01', $_GET["bodyengine"]);
            } elseif (!empty($_GET["production"])&&!empty($_GET["model"])&&!isset($disk_par)) {
                $disk_par = DB::query($request, $_GET["manufacturer"], $_GET["model"],$_GET["production"].'-12-31', $_GET["production"].'-01-01');
            } elseif (!empty($_GET["model"])&&!isset($disk_par)) {
                $disk_par = DB::query($request, $_GET["manufacturer"], $_GET["model"]);
            } else {
                $disk_par = DB::query($request, $_GET["manufacturer"]);
            }
            
            while ($row = DB::fetch_array($disk_par)) {
                // подготовить отсеч дробные части если ониравны 0
                $iga = preg_split("[\.]", $row["width_min"]);
                if (isset($iga[1]) && $iga[1] == '0') $row["width_min"] = (int)$row["width_min"];
                $iga = preg_split("[\.]", $row["width_max"]);
                if (isset($iga[1]) && $iga[1] == '0') $row["width_max"] = (int)$row["width_max"];
                $iga = preg_split("[\.]", $row["et_min"]);
                if (isset($iga[1]) && $iga[1] == '0') $row["et_min"] = (int)$row["et_min"];
                $iga = preg_split("[\.]", $row["et_max"]);
                if (isset($iga[1]) && $iga[1] == '0') $row["et_max"] = (int)$row["et_max"];
               /* $iga = preg_split("[\.]", $row["dia_min"]);
                if ($iga[1] == '0') $row["dia_min"] = (int)$row["dia_min"];
                $iga = preg_split("[\.]", $row["dia_max"]);
                if ($iga[1] == '0') $row["dia_max"] = (int)$row["dia_max"];
                */
                // Делаем выборки по параметрам полученным на основании марки авто
                $where =
                    "INNER JOIN {shop_param_element} AS pe5 ON pe5.`element_id` = s.`id` AND pe5.`trash` = '0' AND pe5.`param_id` = 5 AND (pe5.`value` >= '".(isset($param[5][$row["width_min"]]) ? $param[5][$row["width_min"]] : '')."' AND pe5.`value` <= '".(isset($param[5][$row["width_max"]]) ? $param[5][$row["width_max"]] : '')."') ".
                    "INNER JOIN {shop_param_element} AS pe6 ON pe6.`element_id` = s.`id` AND pe6.`trash` = '0' AND pe6.`param_id` = 6 AND pe6.`value` = '".(isset($param[6][$row["diametr"]]) ? $param[6][$row["diametr"]] : '')."' ".
                    "INNER JOIN {shop_param_element} AS pe7 ON pe7.`element_id` = s.`id` AND pe7.`trash` = '0' AND pe7.`param_id` = 7 AND pe7.`value` = '".(isset($param[7][$row["pcd"]]) ? $param[7][$row["pcd"]] : '')."' ".
                    "INNER JOIN {shop_param_element} AS pe8 ON pe8.`element_id` = s.`id` AND pe8.`trash` = '0' AND pe8.`param_id` = 8 AND (pe8.`value` >= '".$row["et_min"]."' AND pe8.`value` <= '".$row["et_max"]."') ";

                $result = DB::query("SELECT s.`id`, s.`cat_id`, s.`site_id`, s.`name`, s.`hit`, s.`new`, s.`action`, pr.`price` ".
                                "FROM {shop} AS s ".
                                "INNER JOIN {shop_price} AS pr ON pr.good_id = s.id AND pr.trash = '0' ".
                                $where.
                                "WHERE s.[act] = '1' AND s.trash = '0' ".
                                "GROUP BY s.id"
                                );
                 if ($row["parent"] == 1) {
                    while ($row = DB::fetch_array($result)) {
                        $this->result["parent_disk"][] = array('name'=>$row["name"], 'link' => $this->diafan->_route->link($row["site_id"], "shop", $row["cat_id"], $row["id"]), 'hit'=>$row["hit"], 'new'=>$row["new"], 'action'=>$row["action"],  'price'=>$row["price"], 'show_rating' => $this->diafan->_rating->get($row["id"]));
                    }
                } elseif ($row["parent"] == 0) {
                    while ($row = DB::fetch_array($result)) {
                        $this->result["variant_disk"][] = array('name'=>$row["name"], 'link' => $this->diafan->_route->link($row["site_id"], "shop", $row["cat_id"], $row["id"]), 'hit'=>$row["hit"], 'new'=>$row["new"], 'action'=>$row["action"],  'price'=>$row["price"], 'show_rating' => $this->diafan->_rating->get($row["id"]));
                    }                    
                }
                
            }

        }
        $this->result["currency"] = $this->diafan->configmodules("currency", "shop");
	$this->result["view"] = 'list';
	return $this->result;
    }

    
    /**
     * Генерирует данные для первой страницы "Списка автомобилей"
     * 
     * @return boolean
     */
    public function first_page() {
        $this->result["view"] = 'first_page';
        return $this->result;
    }

    /**
     * Генерирует контент для шаблонной функции: форма поиска по товарам
     *
     * @param integer $site_id страница сайта, к которой прикреплен модуль Магазин
     * @return array
     */
    public function show_search($site_id) {
        if (!$site_id) {
            if ($this->diafan->module == "auto") {
                $site_id = $this->diafan->cid;
            } else {
                $site_id = DB::query_result(
                                "SELECT s.id FROM {site} AS s".
                                //. ($this->diafan->_user->id ? " LEFT JOIN {access} AS a ON a.element_id=s.id AND a.module_name='site'" : "")
                                " WHERE s.addmodule='auto' AND s.trash='0' AND s.[act]='1' AND s.block='0'".
                                " AND (s.access='0'".
                                ($this->diafan->_user->id ? " OR s.access='1'"/* AND a.role_id=" . $this->diafan->_user->role_id */ : '').
                                ") LIMIT 1"
                );
            }            
        }
         
        $this->result["path"] = $this->diafan->_route->link($site_id);
        //
        // выбрать уникальные все значения manufacturer group by `name`
        $result = DB::query("SELECT `id`, `manufacturer` FROM {auto} GROUP BY `manufacturer` ASC");
        while ($row = DB::fetch_array($result)) {
            $rows[] = array ('id' => $row["id"], 'manufacturer' => $row["manufacturer"]);
        }
        $this->result["manufacturer"] = $rows;
        return $this->result;
    }
}
?>
